=== debian/changelog ===
sra-sdk (2.0.1-1) unstable; urgency=low

  * Initial release (Closes: #610603).

 -- Charles Plessy <plessy@debian.org>  Tue, 24 May 2011 14:48:10 +0900
