=== debian/watch ===
version=3
http://trace.ncbi.nlm.nih.gov/Traces/sra/sra.cgi?cmd=show&f=software&m=software&s=software static/sra_sdk-(.*).tar.gz
